# -*- makefile -*-


#################################################################
# dictionary targets
#################################################################

DICTS	:= $(addprefix $(ODIR)/,$(addsuffix .dict,$(DICTIONARIES)))
_DICT	= $($(patsubst %.dict,%,$(notdir $1))-$2)
SRCDICT	= $(filter %.dict,$(call _DICT,$@,SRC))
DICT_FS	= $(filter %.fs,$(call _DICT,$@,SRC))

$(word 1,$(DICTS)):	$(call _DICT,$(word 1,$(DICTS)),SRC)
$(word 2,$(DICTS)):	$(call _DICT,$(word 2,$(DICTS)),SRC)
$(word 3,$(DICTS)):	$(call _DICT,$(word 3,$(DICTS)),SRC)
$(word 4,$(DICTS)):	$(call _DICT,$(word 4,$(DICTS)),SRC)
$(word 5,$(DICTS)):	$(call _DICT,$(word 5,$(DICTS)),SRC)
$(word 6,$(DICTS)):	$(call _DICT,$(word 6,$(DICTS)),SRC)
$(word 7,$(DICTS)):	$(call _DICT,$(word 7,$(DICTS)),SRC)
$(word 8,$(DICTS)):	$(call _DICT,$(word 8,$(DICTS)),SRC)
$(word 9,$(DICTS)):	$(call _DICT,$(word 9,$(DICTS)),SRC)

all-local: $(DICTS)

$(DICTS) : % :
	@printf "    Compiling %-20s: " "$(notdir $@)"
	@test -d $(dir $@) || $(INSTALL) -d $(dir $@)
	# Using short options -D and -d since long options only work on GLIBC systems
	unset PRE ; test "$(filter %preprocessor.fs,$^)" = "" && PRE=$(OINC)/prep.fs ; \
	$(BOOTSTRAP) -D $@ -d $(SRCDICT) $$PRE $(DICT_FS) > $@.log \
	   || { echo "failure" ; tail -2 $@.log \
		| sed 's/^/--->   /g' ; exit 1 ; } ; true
	@echo "ok"
