/* tag: the main file which includes all the prim code headers
 *
 * Copyright (C) 2004 Stefan Reinauer
 *
 * see the file "COPYING" for further information about
 * the copyright and warranty status of this work.
 */

#include "libc/byteorder.h"

unsigned int get_le32(const unsigned char *p)
{
	return (p[0] << 0) | (p[1] << 8) | (p[2] << 16) | (p[3] << 24);
}

unsigned int get_le16(const unsigned char *p)
{
	return (p[0] << 0) | (p[1] << 8);
}

unsigned int get_be32(const unsigned char *p)
{
	return (p[3] << 0) | (p[2] << 8) | (p[1] << 16) | (p[0] << 24);
}

unsigned int get_be16(const unsigned char *p)
{
	return (p[1] << 0) | (p[0] << 8);
}

// to create reg properties
unsigned int to_be32(unsigned int w)
{
	return get_be32((const unsigned char *)&w);
}


